/***************************************************************************************
*
*							Main.c
*
*
*
*
* LCD + UART Library von Peter Fleury
*
* Timer1 code basierend auf dem Artikel: "Die genaue Sekunde" von Peter Dannegger
*
*
*****************************************************************************************/


#include "main.h"





int main(void)
{
	int16_t temp_0a = 0, temp_0b=0;
	
		
     //  Initialize UART library, pass baudrate and AVR cpu clock
     //  with the macro 
     // UART_BAUD_SELECT() (normal speed mode )
     // or 
     // UART_BAUD_SELECT_DOUBLE_SPEED() ( double speed mode)
     //
	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU) );
	
	// initialize display, cursor off 
	lcd_init(LCD_DISP_ON);
     
	// initialize 1wire
	init_1wire(); 
	 
	// Timer 1 starten
	init_timer1();

	// now enable interrupt, since UART library is interrupt controlled
    sei();

	// clear display and home cursor 
	lcd_clrscr();
	

	// alle Sensoren resetten => fr Test Fehlercode
	reset_all_1wire();
	
	// Errorcode per UART ausgeben
	show_errorcode_1wire();	
	
	
	
		
	lcd_gotoxy(0,3);
	lcd_puts("*** DS18B20_test ***");
	
	
	DDRC |= 1<<PC4;	// LED als Kontrolle fr Sekundentakt	

	for(;;)
	{
		
			
		if(sekunde == 0)
		{
			PORTC ^= 1<<PC4;
			
			reset_1wire();
			
			write_byte_1wire(SKIP_ROM);
			
			write_byte_1wire(CONVERT_TEMP);
			
			sekunde = 1;			
		}
		
		

		if(sekunde == 2)
		{
			
			
			reset_1wire();
			
			write_byte_1wire(SKIP_ROM);					// Befehl "berspringe ROM" senden
			
			write_byte_1wire(READ_SCRATCHPAD);			// Befehl "Lese SCRATCHPAD" senden
			
						
			temp_0a = read_temp_1wire (0 , 'a');		// Temparatur 0a lesen
			display_temp_1wire (temp_0a , 0 , 0);		// Temparatur 0a anzeigen
			
			temp_0b = read_temp_1wire (0 , 'b');		// Temparatur 0b lesen
			display_temp_1wire (temp_0b , 0 , 1);		// Temparatur 0b anzeigen
			
			sekunde = 0;
		}
	}
}




